<script lang="ts">
import { MetaInfo } from 'vue-meta/types/vue-meta';
import Vue from 'vue';
import { CTA as CallToAction, Faq } from '~/components/common/index.vue';
import { FreeTrialPlans } from '~/components/free-trial/index.vue';
import { getPageMetadata } from '~/common/meta';
import { PageDTO } from '~/models/page.dto';

export default Vue.extend({
  name: 'FreeTrial',
  components: {
    FreeTrialPlans,
    Faq,
    CallToAction,
  },
  async asyncData({ error, $freeTrialService }: any) {
    try {
      // We pass TRUE as second argument because this is an index slug
      const doc: PageDTO = await $freeTrialService.getContent(
        `free-trial`,
        true,
      );

      return { doc };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).doc,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <SlpContainer>
    <component
      :is="component.name"
      v-for="component in doc?.components"
      :key="component.name"
      :data="component.data"
    >
    </component>
  </SlpContainer>
</template>
